package cn.com.infosec.asn1;

import java.io.ByteArrayOutputStream;
import java.io.IOException;
import java.util.Enumeration;
import java.util.Vector;

public class BERConstructedOctetString extends DEROctetString {
   private static final int MAX_LENGTH = 1000;
   private Vector octs;

   private static byte[] toBytes(Vector octs) {
      ByteArrayOutputStream var1;
      var1 = new ByteArrayOutputStream.<init>();

      for(int var2 = 0; var2 != octs.size(); ++var2) {
         try {
            var1.write(((DEROctetString)octs.elementAt(var2)).getOctets());
         } catch (ClassCastException var3) {
            throw new IllegalArgumentException(octs.elementAt(var2).getClass().getName() + " found in input should only contain DEROctetString");
         } catch (IOException var4) {
            throw new IllegalArgumentException("exception converting octets " + var4.toString());
         }
      }

      return var1.toByteArray();
   }

   public BERConstructedOctetString(byte[] string) {
      super(string);
   }

   public BERConstructedOctetString(Vector octs) {
      super(toBytes(octs));
      this.octs = octs;
   }

   public BERConstructedOctetString(DERObject obj) {
      super((DEREncodable)obj);
   }

   public BERConstructedOctetString(DEREncodable obj) {
      super((DEREncodable)obj.getDERObject());
   }

   private Vector generateOcts() {
      int var1 = 0;
      int var2 = 0;
      Vector var3;
      var3 = new Vector.<init>();

      int var4;
      byte[] var5;
      for(; (var4 = var2 + 1) < (var5 = super.string).length; var2 = var4) {
         if (var5[var2] == 0 && var5[var4] == 0) {
            byte[] var8;
            System.arraycopy(var5, var1, var8 = new byte[var1 = var2 - var1 + 1], 0, var1);
            var3.addElement(new DEROctetString(var8));
            var1 = var4;
         }
      }

      int var6;
      byte[] var7;
      System.arraycopy(var5, var1, var7 = new byte[var6 = var5.length - var1], 0, var6);
      var3.addElement(new DEROctetString(var7));
      return var3;
   }

   public byte[] getOctets() {
      return super.string;
   }

   public Enumeration getObjects() {
      Vector var1;
      return (var1 = this.octs) == null ? this.generateOcts().elements() : var1.elements();
   }

   public void encode(DEROutputStream out) {
      if (!(out instanceof ASN1OutputStream) && !(out instanceof BEROutputStream)) {
         super.encode(out);
      } else {
         out.write(36);
         out.write(128);
         int var2;
         byte[] var3;
         int var4;
         if (this.octs != null) {
            for(var2 = 0; var2 != this.octs.size(); ++var2) {
               out.writeObject(this.octs.elementAt(var2));
            }
         } else {
            for(var2 = 0; var2 < (var3 = super.string).length; var2 = var4) {
               int var5;
               if ((var4 = var2 + 1000) > var3.length) {
                  var5 = var3.length;
               } else {
                  var5 = var4;
               }

               int var7;
               byte[] var8 = new byte[var7 = var5 - var2];
               System.arraycopy(var3, var2, var8, 0, var7);
               DEROctetString var6;
               var6 = new DEROctetString.<init>(var8);
               out.writeObject(var6);
            }
         }

         out.write(0);
         out.write(0);
      }

   }
}
